package aexp.pagelist2;

import android.app.ListActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import com.commonsware.cwac.endless.EndlessAdapter;
import java.util.ArrayList;

public class PageList2 extends ListActivity
{
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        datasource = new DataSource();
		setListAdapter( new DataSourceAdapter( datasource ) );
    }

    private DataSource datasource;

	class DataSourceAdapter extends EndlessAdapter {
        private DataSource datasource;
        int lastItemIndex = 0;
        static final int PAGELEN = 5;
        private ArrayList<String> cachedItems = new ArrayList<String>();
        private static final String LOG_TAG = "DATASOURCEADAPTER";

		DataSourceAdapter( DataSource datasource ) {
			super(new ArrayAdapter<String>( PageList2.this,
										R.layout.item_row,
										R.id.item_text,
							            new ArrayList<String>() ));
            this.datasource = datasource;
		}
		
		protected View getPendingView(ViewGroup parent) {
			View row=getLayoutInflater().inflate(R.layout.item_row, null);
			
			View child=row.findViewById( R.id.item_text );
			
			child.setVisibility( View.GONE );
			
			child = row.findViewById( R.id.item_loading );
			child.setVisibility( View.VISIBLE );
			
			return( row );
		}
		
		protected void rebindPendingView(int position, View row) {
			View child=row.findViewById( R.id.item_text );
			
			child.setVisibility(View.VISIBLE);
			((TextView)child).setText(getWrappedAdapter().
                    getItem(position).
                    toString());
			child=row.findViewById( R.id.item_loading );
			child.setVisibility(View.GONE);
		}
		
		protected boolean cacheInBackground() {
            Log.d( LOG_TAG, "cacheInBackground" );
            int itemCtr = 0;
            cachedItems.clear();
            while( lastItemIndex < datasource.getItemCount() ) {
                String item = datasource.getItem( lastItemIndex++ );
                cachedItems.add( item );
                if( ++itemCtr >= PAGELEN )
                    break;
            }
            boolean result = lastItemIndex+1 < datasource.getItemCount();
            Log.d( LOG_TAG, "cacheInBackground: "+result+"; cachedItems: "+cachedItems );
			return result;
		}
		
		protected void appendCachedData() {
            Log.d( LOG_TAG, "appendCachedData" );
			ArrayAdapter<String> a=(ArrayAdapter<String>)getWrappedAdapter();
			for ( String item : cachedItems )
				a.add(item);
            Log.d( LOG_TAG, "appendCachedData ends" );
		}
	}

}
